(function ($) {
    $(function () {


        // submit blog search
        $('#searchbtnsubmit').click(function (e){
            e.preventDefault();
            var input = $('#searchbtninput').val();
            if( input )
            {
                var slugstring = '';
                if(franchiseslug)
                    slugstring = "/" + franchiseslug;
    
                window.location.href = slugstring + "/blog/search/" + input + "/#publicblogarticles";
            }
        });
        $('#searchbtninput').on('keyup', function (e){
            if(e.keyCode == 13){
                var input = $('#searchbtninput').val();
                if( input )
                {  
                    var slugstring = '';
                    if(franchiseslug)
                        slugstring = "/" + franchiseslug;
                    window.location.href = slugstring + "/blog/search/" + input + "/#publicblogarticles";
                }
            }
        });


        // smooth scroll to anchor on same page
        $('a[href*=#]:not([href=#])').click(function (e) {
            if (location.pathname.replace(/^\//, '') == this.pathname.replace(/^\//, '') && location.hostname == this.hostname) {
                var target = $(this.hash);
                target = target.length ? target : $('[name=' + this.hash.slice(1) + ']');
                if (target.length) {
                    var $tab = $('#mobileNav .tab');
                    var $body = $('body');
                    if ($body.hasClass('showMobileNav')) {
                        $body.removeClass('showMobileNav');
                        $tab.text('Menu');
                    }
                    $('html,body').animate({
                        scrollTop: target.offset().top - 60
                    }, 800);
                    return false;
                }
            }
        });


        // swap main menu info/icon when hovering on submenu
        $('.publicheadernav-submenu .publicheadernavitem a').hover(function (e) {
            e.preventDefault();
            var $this = $(this);
            var thisIcon = $this.data('icon');
            var thisInfo = $this.data('info');
            var menuContainer = $this.parent().parent().parent();
            var iconContainer = menuContainer.find('.publicheadernav-submenuleft').find('.publicheadernav-submenuicon');
            var infoContainer = menuContainer.find('.publicheadernav-submenuleft').find('.publicheadernav-submenuinfo');
            var newIconStyle = 'url(app/images/public/' + thisIcon;
            iconContainer.css('background-image', newIconStyle);
            infoContainer.text(thisInfo);
        });


        // Mobile nav slider
        $('#mobileNav .tab').click(function (e) {
            e.preventDefault();
            var $tab = $('#mobileNav .tab');
            var $body = $('body');
            if ($body.hasClass('showMobileNav')) {
                $body.removeClass('showMobileNav');
                $body.removeClass('modal-open');
            } else {
                $body.addClass('showMobileNav');
                $body.addClass('modal-open');
            }
        });
        $('#mobileNav .publicheadernavitem-hassubmenu .submenutrigger').click(function (e) {
            e.preventDefault();
            var $this = $(this).parent().parent();
            if ($this.hasClass('shown')) {
                $this.removeClass('shown');
            } else {
                $this.addClass('shown');
            }
        });
        $('#mobileNav .publicheadernavitem-hassubmenu .submenushadow').click(function (e) {
            e.preventDefault();
            $(this).parent().removeClass('shown');
        });


        // show/hide location modal
        /*
        $('#locationmodaltrigger').click(function(e){
            e.preventDefault();
            $('body').addClass('showlocationmodal');
            $('body').addClass('modal-open');
                    $('#locationmodal').load('/modal_location.php');
        });
        */


        // show/hide program units
        $('#publicpageunitslider .publicpageunitsliderpic').not('#publicpageunitslider .publicunitsliderpopupclose').click(function (e) {
            e.preventDefault();
            var thismodalid = $(this).data('popup');
            $('#' + thismodalid).addClass('shown');
            $('#publicunitsliderpopupmodalshade').addClass('shown');
            $('body').addClass('modal-open');
        });
        $('#publicunitsliderpopupmodalshade, #publicpageunitslider .publicunitsliderpopupclose').click(function (e) {
            e.preventDefault();
            $('#publicunitsliderpopupmodalshade').removeClass('shown');
            $('.publicunitsliderpopup.shown').removeClass('shown');
            $('body').removeClass('modal-open');
        });


        // show/hide party packages
        // removed for now, no popups as corp doesn't popup and franch info is in the visible block
        // $('#publicpackageblocks .packageblock').not('#publicpackageblocks .publicpackageblockpopupclose').click(function(e){
        // 	e.preventDefault();
        // 	var thismodalid = $(this).data('popup');
        // 	$('#'+thismodalid).addClass('shown');
        // 	$('#publicpackageblockpopupmodalshade').addClass('shown');
        // 	$('body').addClass('modal-open');
        // });
        // $('#publicpackageblockpopupmodalshade, #publicpackageblocks .publicpackageblockpopupclose').click(function(e){
        // 	e.preventDefault();
        // 	$('#publicpackageblockpopupmodalshade').removeClass('shown');
        // 	$('.publicpackageblockpopup.shown').removeClass('shown');
        // 	$('body').removeClass('modal-open');
        // });


        // swap schedule description on a single location page
        $('.franchiseschedulesmulti .franchiseschedule').click(function (e) {
            e.preventDefault();
            var $this = $(this);
            var thistriggerid = $this.data('trigger');
            $('.franchiseschedulesmulti .franchiseschedule.active').removeClass('active');
            $('.publiclocationsummarydescriptions .active').removeClass('active');
            $this.addClass('active');
            $('#' + thistriggerid).addClass('active');
        });


        // normalize heights of title element for franchise page latest blog articles
        if ($('#publicfranchiselatestblog').length > 0) {
            var maxHeight = -1;
            $('#publicfranchiselatestblog .blogarticletitle').each(function(e){
                maxHeight = maxHeight > $(this).height() ? maxHeight : $(this).height();
            });
            $('#publicfranchiselatestblog .blogarticletitle').each(function(e){
                $(this).height(maxHeight);
            });
        }


        // program unit slick slider
        $('#publicpageunitslider .publicpageunitsliderpics').slick({
            infinite: true,
            speed: 300,
            slidesToShow: 4,
            slidesToScroll: 1,
            autoplay: true,
            autoplaySpeed: 3000,
            responsive: [
                {
                    breakpoint: 900,
                    settings: {
                        slidesToShow: 3,
                        slidesToScroll: 1,
                    }
                },
                {
                    breakpoint: 600,
                    settings: {
                        slidesToShow: 2,
                        slidesToScroll: 1
                    }
                },
                {
                    breakpoint: 400,
                    settings: {
                        slidesToShow: 1,
                        slidesToScroll: 1
                    }
                }
            ],
            prevArrow: '<button type="button" class="slick-prev"><i class="fas fa-angle-left"></i></button>',
            nextArrow: '<button type="button" class="slick-next"><i class="fas fa-angle-right"></i></button>',
        });


        // slideshow for homepage pitch section
        var pitchSlidesCnt = $('#publicpitchslides').children().length;
        if (pitchSlidesCnt > 1) {
            var pitchRotationTime = 5000;
            var pitchSlides = $('#publicpitchslides');

            // start slide rotation
            var pitchSlidesInterval = setTimeout(pitchRotateSlides, pitchRotationTime);
            function pitchRotateSlides(pitchNextSlide) {

                clearTimeout(pitchSlidesInterval);
                var activeSlide = pitchSlides.find('.active');
                pitchSlides.find('.active').removeClass('active');
                if (!pitchNextSlide) {
                    pitchNextSlide = activeSlide.next();
                    if (!pitchNextSlide.length) {
                        pitchNextSlide = activeSlide.siblings(':first');
                    }
                }
                pitchNextSlide.addClass('active');
                pitchSlidesInterval = setTimeout(pitchRotateSlides, pitchRotationTime);
            }

        }


        // slideshow for pages with multiple slides
        var slidesCnt = $('#slideshow #slides').children().length;
        if (slidesCnt > 1) {
            var rotationTime = 8000;
            var slidesWrap = $('#slideshow');
            var slides = $('#slideshow #slides');
            var slidesNav = $('#slideshow #slide_nav');

            // initialize; append nav html and set first to checked
            for (var i = 0; i < slidesCnt; i++) {
                slidesNav.append('<div id="slide-' + i + '" class="radio_wrap"></div>');
            }
            slidesNav.find('.radio_wrap:nth-child(1)').addClass('checked');

            // start slide rotation
            var myNavInterval = setTimeout(rotateSlides, rotationTime);
            function rotateSlides(nextCircle) {
                clearTimeout(myNavInterval);
                slides.find('.active').removeClass('active');
                var activeCircle = slidesNav.find('.checked').removeClass('checked');
                if (!nextCircle) {
                    nextCircle = activeCircle.next();
                    if (!nextCircle.length) {
                        nextCircle = activeCircle.siblings(':first');
                    }
                }
                nextCircle.addClass('checked');
                slides.find('.slide[img_id=' + $.trim(nextCircle.attr('id')) + ']').addClass('active');
                myNavInterval = setTimeout(rotateSlides, rotationTime);
            }

            // interrupt rotation
            slidesNav.find('.radio_wrap').click(function () {
                rotateSlides($(this));
                return false;
            });
        }


        // testimonial slider
        var $testSlides = $('.test_slides');
        $testSlides.height($('.test_slide.current').height());
        $(window).resize(function () {
            $testSlides.height($('.test_slide.current').height());
        });
        $('.test_next').click(function () {

            var currnav = $('#testslide_nav').find('.radio_wrap.checked');
            var newnav = currnav.next('.radio_wrap');
            if (newnav.length === 0) { newnav = $('#testslide_nav').find('.radio_wrap:first'); }
            currnav.removeClass('checked');
            newnav.addClass('checked');

            var nextnav1 = newnav.next('.radio_wrap');
            if (nextnav1.length === 0) { nextnav1 = $('#testslide_nav').find('.radio_wrap:first'); }
            var nextnav2 = nextnav1.next('.radio_wrap');
            if (nextnav2.length === 0) { nextnav2 = $('#testslide_nav').find('.radio_wrap:first'); }
            var nextnav3 = nextnav2.next('.radio_wrap');
            if (nextnav3.length === 0) { nextnav3 = $('#testslide_nav').find('.radio_wrap:first'); }
            var nextnav4 = nextnav3.next('.radio_wrap');
            if (nextnav4.length === 0) { nextnav4 = $('#testslide_nav').find('.radio_wrap:first'); }
            $('#testslide_nav').find('.radio_wrap').removeClass('checkednext1 checkednext2 checkednext3 checkednext4');
            nextnav1.addClass('checkednext1');
            nextnav2.addClass('checkednext2');
            nextnav3.addClass('checkednext3');
            nextnav4.addClass('checkednext4');
            var prevnav1 = newnav.prev('.radio_wrap');
            if (prevnav1.length === 0) { prevnav1 = $('#testslide_nav').find('.radio_wrap:last'); }
            var prevnav2 = prevnav1.prev('.radio_wrap');
            if (prevnav2.length === 0) { prevnav2 = $('#testslide_nav').find('.radio_wrap:last'); }
            var prevnav3 = prevnav2.prev('.radio_wrap');
            if (prevnav3.length === 0) { prevnav3 = $('#testslide_nav').find('.radio_wrap:last'); }
            var prevnav4 = prevnav3.prev('.radio_wrap');
            if (prevnav4.length === 0) { prevnav4 = $('#testslide_nav').find('.radio_wrap:last'); }
            $('#testslide_nav').find('.radio_wrap').removeClass('checkedprev1 checkedprev2 checkedprev3 checkedprev4');
            prevnav1.addClass('checkedprev1');
            prevnav2.addClass('checkedprev2');
            prevnav3.addClass('checkedprev3');
            prevnav4.addClass('checkedprev4');

            var curr = $testSlides.find('.current');
            var next = curr.next('.test_slide');
            if (next.length === 0) { next = $testSlides.find('.test_slide:first'); }
            curr.removeClass('current').addClass('prev-left');
            $testSlides.animate({ height: next.height() }, 300);
            next.addClass('current');
            setTimeout(function () { curr.removeClass('prev-left'); }, 400);
        });
        $('.test_prev').click(function () {

            var currnav = $('#testslide_nav').find('.radio_wrap.checked');
            var newnav = currnav.prev('.radio_wrap');
            if (newnav.length === 0) { newnav = $('#testslide_nav').find('.radio_wrap:last'); }
            currnav.removeClass('checked');
            newnav.addClass('checked');

            var nextnav1 = newnav.next('.radio_wrap');
            if (nextnav1.length === 0) { nextnav1 = $('#testslide_nav').find('.radio_wrap:first'); }
            var nextnav2 = nextnav1.next('.radio_wrap');
            if (nextnav2.length === 0) { nextnav2 = $('#testslide_nav').find('.radio_wrap:first'); }
            var nextnav3 = nextnav2.next('.radio_wrap');
            if (nextnav3.length === 0) { nextnav3 = $('#testslide_nav').find('.radio_wrap:first'); }
            var nextnav4 = nextnav3.next('.radio_wrap');
            if (nextnav4.length === 0) { nextnav4 = $('#testslide_nav').find('.radio_wrap:first'); }
            $('#testslide_nav').find('.radio_wrap').removeClass('checkednext1 checkednext2 checkednext3 checkednext4');
            nextnav1.addClass('checkednext1');
            nextnav2.addClass('checkednext2');
            nextnav3.addClass('checkednext3');
            nextnav4.addClass('checkednext4');
            var prevnav1 = newnav.prev('.radio_wrap');
            if (prevnav1.length === 0) { prevnav1 = $('#testslide_nav').find('.radio_wrap:last'); }
            var prevnav2 = prevnav1.prev('.radio_wrap');
            if (prevnav2.length === 0) { prevnav2 = $('#testslide_nav').find('.radio_wrap:last'); }
            var prevnav3 = prevnav2.prev('.radio_wrap');
            if (prevnav3.length === 0) { prevnav3 = $('#testslide_nav').find('.radio_wrap:last'); }
            var prevnav4 = prevnav3.prev('.radio_wrap');
            if (prevnav4.length === 0) { prevnav4 = $('#testslide_nav').find('.radio_wrap:last'); }
            $('#testslide_nav').find('.radio_wrap').removeClass('checkedprev1 checkedprev2 checkedprev3 checkedprev4');
            prevnav1.addClass('checkedprev1');
            prevnav2.addClass('checkedprev2');
            prevnav3.addClass('checkedprev3');
            prevnav4.addClass('checkedprev4');

            var curr = $testSlides.find('.current');
            var prev = curr.prev('.test_slide');
            if (prev.length === 0) { prev = $testSlides.find('.test_slide:last'); }
            curr.removeClass('current').addClass('prev-right');
            prev.addClass('before-left');
            $testSlides.animate({ height: prev.height() }, 300);
            prev.addClass('current').removeClass('before-left');
            setTimeout(function () { curr.removeClass('prev-right'); }, 400);
        });
        // slideshow for testimonial slides
        var slidesCnt = $('#testslides').children().length;
        if (slidesCnt > 1) {
            var rotationTime = 8000;
            //var slidesWrap = $('#slideshow');
            var slides = $('#testslides');
            var slidesNav = $('#testslide_nav');

            // start slide rotation
            var myNavInterval = setTimeout(rotateSlides, rotationTime);
            function rotateSlides(newnav) {
                clearTimeout(myNavInterval);
                slides.find('.current').removeClass('current');

                var currnav = slidesNav.find('.checked').removeClass('checked');
                if (!newnav) {
                    newnav = currnav.next();
                    if (!newnav.length) {
                        newnav = currnav.siblings(':first');
                    }
                }
                newnav.addClass('checked');

                var nextnav1 = newnav.next('.radio_wrap');
                if (nextnav1.length === 0) { nextnav1 = $('#testslide_nav').find('.radio_wrap:first'); }
                var nextnav2 = nextnav1.next('.radio_wrap');
                if (nextnav2.length === 0) { nextnav2 = $('#testslide_nav').find('.radio_wrap:first'); }
                var nextnav3 = nextnav2.next('.radio_wrap');
                if (nextnav3.length === 0) { nextnav3 = $('#testslide_nav').find('.radio_wrap:first'); }
                var nextnav4 = nextnav3.next('.radio_wrap');
                if (nextnav4.length === 0) { nextnav4 = $('#testslide_nav').find('.radio_wrap:first'); }
                $('#testslide_nav').find('.radio_wrap').removeClass('checkednext1 checkednext2 checkednext3 checkednext4');
                nextnav1.addClass('checkednext1');
                nextnav2.addClass('checkednext2');
                nextnav3.addClass('checkednext3');
                nextnav4.addClass('checkednext4');
                var prevnav1 = newnav.prev('.radio_wrap');
                if (prevnav1.length === 0) { prevnav1 = $('#testslide_nav').find('.radio_wrap:last'); }
                var prevnav2 = prevnav1.prev('.radio_wrap');
                if (prevnav2.length === 0) { prevnav2 = $('#testslide_nav').find('.radio_wrap:last'); }
                var prevnav3 = prevnav2.prev('.radio_wrap');
                if (prevnav3.length === 0) { prevnav3 = $('#testslide_nav').find('.radio_wrap:last'); }
                var prevnav4 = prevnav3.prev('.radio_wrap');
                if (prevnav4.length === 0) { prevnav4 = $('#testslide_nav').find('.radio_wrap:last'); }
                $('#testslide_nav').find('.radio_wrap').removeClass('checkedprev1 checkedprev2 checkedprev3 checkedprev4');
                prevnav1.addClass('checkedprev1');
                prevnav2.addClass('checkedprev2');
                prevnav3.addClass('checkedprev3');
                prevnav4.addClass('checkedprev4');

                var mesajarjar = slides.find('.test_slide[img_id=' + $.trim(newnav.attr('id')) + ']');
                mesajarjar.addClass('current');
                $testSlides.animate({ height: mesajarjar.height() }, 300);
                myNavInterval = setTimeout(rotateSlides, rotationTime);
            }

            // interrupt rotation
            slidesNav.find('.radio_wrap').click(function () {
                rotateSlides($(this));
                return false;
            });
        }


        // blog sidebar sections show/hide
        $('.blogsidebarheading').click(function (e) {
            e.preventDefault();
            $this = $(this);
            $triggerid = $this.data('id');
            $('#' + $triggerid + ' .blogsidebarsectioncontent').toggle();
        });


        // start counters on stats (stagger speed)
        $('.counter1').counterUp({
            time: 1500
        });
        $('.counter2').counterUp({
            time: 2000
        });
        $('.counter3').counterUp({
            time: 2500
        });
        $('.counter4').counterUp({
            time: 2200
        });


        // waypoint for affixing header on scroll
        var waypoints = $('#publicheadernavbar').waypoint(
            function (direction) {
                if (direction == 'down') {
                    $('header').addClass('fixedheader');
                    $('#publicfooterloccta').addClass('stuck');
                }
                if (direction == 'up') {
                    $('header').removeClass('fixedheader');
                    $('#publicfooterloccta').removeClass('stuck');
                }
            }, {
            offset: function () {
                return $('#publicheadernavbar').offset().top - 74
            }
        });


        // waypoint for ruler animation start
        var waypoints = $('#publicgrowthruler').waypoint(function (direction) {
            $('#publicgrowthruler').addClass('triggergrowth')
        }, {
            offset: '80%'
        });


        // show/hide footer find-a-location cta
        $('#publicfooterlocctatrigger').click(function (e) {
            e.preventDefault();
            if ($('#publicfooterloccta').hasClass('stuck')) {
                $('#publicfooterloccta').removeClass('stuck');
            } else {
                $('#publicfooterloccta').addClass('stuck');
            }
        });


        // toggle age progression items
        $('.publicagesblockbuttongroup').click(function () {
            var $this = $(this);
            var agesparent = $this.parent().parent();
            agesparent.find($('.publicagescircle')).addClass('shift');
            $('.publicagesblockimage[data-ageimg="' + $this.data('agebtn') + '"]').addClass('shown');
        });
        $('.publicagesblockdualtrigger').click(function () {
            var $this = $(this);
            var agesparent = $this.parent().parent().parent().parent();
            agesparent.find($('.publicagescircle')).addClass('shift');
            $('.publicagesblockimage[data-ageimg="' + $this.data('agebtn') + '"]').addClass('shown');
        });
        $('.publicagesblockimageclose').click(function () {
            var $this = $(this);
            var agesparent = $this.parent().parent().parent();
            agesparent.find($('.publicagescircle')).removeClass('shift');
            $this.parent().removeClass('shown');
        });


        // colorbox on homepage video popup
        $('.play_video').click(wireColorbox);


        // colorbox on gallery
        $('.gallery a').colorbox({
            maxWidth: '80%',
            maxHeight: '80%',
            opacity: 0.7,
            transition: 'none',
            current: '',
            onOpen: function () {
                prefix = 'cbox';
                $('#cboxWrapper').append(
                    $prev = $('<button type="button"/>').attr("class", prefix + 'Previous').attr('id', prefix + 'Previous'),
                    $next = $('<button type="button"/>').attr("class", prefix + 'Next').attr('id', prefix + 'Next')
                );
                $('#cboxContent #cboxPrevious, #cboxContent #cboxNext').remove();
                $('.cboxNext').click(function () {
                    $.colorbox.next();
                });
                $('.cboxPrevious').click(function () {
                    $.colorbox.prev();
                });
            }
        });


        // change country
        $('.franchise-country').change(function () {
            var thisParent = $(this).parent();
            var thisCountry = thisParent.find('.franchise-country');

            if (thisCountry.val() != '') {
                setCookie('team_country', thisCountry.val(), 1);
                eraseCookie('team_state');
                eraseCookie('team_city');
            }
            else {
                eraseCookie('team_country');
                eraseCookie('team_state');
                eraseCookie('team_city');
            }

            window.location = '/about/team/';
            //location.reload(true);
        });


        // change state
        $('.franchise-state').change(function () {
            var thisParent = $(this).parent();
            var thisState = thisParent.find('.franchise-state');

            if (thisState.val() != '') {
                setCookie('team_state', thisState.val(), 1);
                eraseCookie('team_city');
            }
            else {
                eraseCookie('team_state');
                eraseCookie('team_city');
            }

            window.location = '/about/team/';
            //location.reload(true);
        });

        // change city
        $('.franchise-city').change(function () {
            var thisParent = $(this).parent();
            var thisCity = thisParent.find('.franchise-city');

            if (thisCity.val() != '') {
                setCookie('team_city', thisCity.val(), 1);
            }
            else {
                eraseCookie('team_city');
            }

            window.location = '/about/team/';
            //location.reload(true);
        });


        // show/hide schedule type modal on franchise page
        $('.franchiseschedulesprograms').click(function (e) {
            e.preventDefault();
            var $this = $(this);
            var trigger = $this.data('trigger');
            $('.franchiseschedulesprogramswrap').find('.franchiseschedulesprogrammodal').each(function () {
                $(this).removeClass('shown');
                $('body').removeClass('modal-open');
            });
            $('#franchiseschedulesprogrammodal_' + trigger).addClass('shown');
            $('body').addClass('modal-open');
        });
        $('.franchiseschedulesprogrammodalpopupclose, .franchiseschedulesprogrammodalshade').click(function (e) {
            e.preventDefault();
            $('.franchiseschedulesprogramswrap').find('.franchiseschedulesprogrammodal').each(function () {
                $(this).removeClass('shown');
                $('body').removeClass('modal-open');
            });
        });
        $('.franchiseschedulesprogrammodalenroll').click(function (e) {
            e.preventDefault();
            $('.franchiseschedulesprogramswrap').find('.franchiseschedulesprogrammodal').each(function () {
                $(this).removeClass('shown');
                $('body').removeClass('modal-open');
            });
            var $this = $(this);
            var filter = $this.data('filter');
            $('#franchschedlocfilter').val('0');
            $('#franchscheddatepicker').datepicker('setDate', null);
            $('table.franchiseschedules').find('.franchiseschedule').each(function () {
                var $that = $(this);
                if (filter == 0) {
                    $that.removeClass('hidden');
                } else {
                    var programid = $that.data('programid');
                    if (filter != programid) {
                        $that.addClass('hidden');
                    } else {
                        $that.removeClass('hidden');
                    }
                }
            });
            $('#franchschedprogfilter option').filter(function () {
                return ($(this).val() == filter);
            }).prop('selected', true);
        });


        // un-filter schedules on franchise page
        $('#franchschedunfilter').click(function (e) {
            e.preventDefault();
            $('#franchschedlocfilter').val('0');
            $('#franchschedprogfilter').val('0');
            $('#franchscheddatepicker').datepicker('setDate', null);
            $('table.franchiseschedules').find('.franchiseschedule').each(function () {
                $(this).removeClass('hidden');
            });
        });
        // filter schedules on franchise page by date
        $('#franchscheddatepicker').datepicker({
            dateFormat: 'yy-mm-dd',
            onSelect: function (dateText) {
                var date = dateText;
                $('#franchschedlocfilter').val('0');
                $('#franchschedprogfilter').val('0');
                $('table.franchiseschedules').find('.franchiseschedule').each(function () {
                    var $that = $(this);
                    $that.removeClass('hidden');
                    var start = $that.data('start');
                    var end = $that.data('end');
                    if (date < start || date > end) {
                        $that.addClass('hidden');
                    }
                });
            }
        });
        // filter schedules on franchise page by program
        $('#franchschedprogfilter').change(function (e) {
            e.preventDefault();
            var $this = $(this);
            var filter = $this.val();
            $('#franchschedlocfilter').val('0');
            $('#franchscheddatepicker').datepicker('setDate', null);
            $('table.franchiseschedules').find('.franchiseschedule').each(function () {
                var $that = $(this);
                if (filter == 0) {
                    $that.removeClass('hidden');
                } else {
                    var programid = $that.data('programid');
                    if (filter != programid) {
                        $that.addClass('hidden');
                    } else {
                        $that.removeClass('hidden');
                    }
                }
            });
        });
        // filter schedules on franchise page by location
        $('#franchschedlocfilter').change(function (e) {
            e.preventDefault();
            var $this = $(this);
            var filter = $this.val();
            $('#franchschedprogfilter').val('0');
            $('#franchscheddatepicker').datepicker('setDate', null);
            $('table.franchiseschedules').find('.franchiseschedule').each(function () {
                var $that = $(this);
                if (filter == 0) {
                    $that.removeClass('hidden');
                } else {
                    var locationid = $that.data('locationid');
                    if (filter != locationid) {
                        $that.addClass('hidden');
                    } else {
                        $that.removeClass('hidden');
                    }
                }
            });
        });


        // set height of video player for news page, setTimeout just for fun
        if ($('#youtube_video').hasClass('newspagevideo')) {
            setTimeout(function () {
                var vidblockw = $('#publicnewscorporatevideos').width();
                var vidblockh = vidblockw * 0.5625;
                var vidiframe = $('iframe#youtube_video.newspagevideo');
                vidiframe.attr('width', vidblockw);
                vidiframe.attr('height', vidblockh);
            }, 0);
        }
        // set height of video player for franchise page, setTimeout just for fun
        if ($('#youtube_video').hasClass('franchisepagevideo')) {
            setTimeout(function () {
                var vidblockw = $('#publicfranchisesocialfeedvideos').width();
                var vidblockh = vidblockw * 0.5625;
                var vidiframe = $('iframe#youtube_video.franchisepagevideo');
                vidiframe.attr('width', vidblockw);
                vidiframe.attr('height', vidblockh);
            }, 0);
        }


        // choose what to display in the social feed section of the franchise page
        if (channelID || watchID || listID) {
            if (channelID) {
                var reqURL = "https://www.youtube.com/feeds/videos.xml?channel_id=";
                $.getJSON("https://api.rss2json.com/v1/api.json?rss_url=" + encodeURIComponent(reqURL) + channelID, function (data) {
                    var link = data.items[0].link;
                    var id = link.substr(link.indexOf("=") + 1);
                    $("#youtube_video").attr("src", "https://youtube.com/embed/" + id + "?controls=1&showinfo=0&rel=0");
                });
            }
            if (watchID) {
                $("#youtube_video").attr("src", "https://youtube.com/embed/" + watchID + "?controls=1&showinfo=0&rel=0");
            }
            if (listID) {
                $("#youtube_video").attr("src", "https://youtube.com/embed/videoseries?list=" + listID + "?controls=1&showinfo=0&rel=0");
            }
        } else if (corpChannelID) {
            // TODO = find out what they want to display here if franchise doesn't have a youtube link.
            // This is currently set to display the latest video from the B4K main channel.
            var reqURL = "https://www.youtube.com/feeds/videos.xml?channel_id=";
            $.getJSON("https://api.rss2json.com/v1/api.json?rss_url=" + encodeURIComponent(reqURL) + corpChannelID, function (data) {
                var link = data.items[0].link;
                var id = link.substr(link.indexOf("=") + 1);
                $("#youtube_video").attr("src", "https://youtube.com/embed/" + id + "?controls=1&showinfo=0&rel=0");
            });
        }


        // show/hide birthday request form
        $('#requestpartytrigger, #requestpartyblockstrigger, .publicpackageblocksmobilebutton').click(function (e) {
            e.preventDefault();
            $('body').addClass('modal-open');
            $('#birthdayrequestform').addClass('shown');
            $('#birthdayrequestshade').addClass('shown');
        });
        $('#birthdayrequestshade').click(function (e) {
            e.preventDefault();
            $('body').removeClass('modal-open');
            $('#birthdayrequestform').removeClass('shown');
            $('#birthdayrequestshade').removeClass('shown');
        });


        // submit the birthday party request form to ajax
        $('#birthdaypartyrequestform').submit(function (e) {
            e.preventDefault();
            var $this = $(this);
            var thisParent = $('#birthdayrequestform');
            var franchiseid = $this.find('[name="franchiseid"]');
            var name = $this.find('[name="name"]');
            var email = $this.find('[name="email"]');
            var phone = $this.find('[name="phone"]');
            var date = $this.find('[name="date"]');
            var time = $this.find('[name="time"]');
            var zip = $this.find('[name="zip"]');
            var country = $this.find('[name="country"]');
            var packagetype = $this.find('[name="packagetype"]:checked');
            var comments = $this.find('[name="comments"]');
            thisParent.removeClass('formerror');
            thisParent.removeClass('formemailerror');
            $this.find('input[type="text"]').removeClass('fielderror');

            // validate form data
            var formvalidated = true;
            var testexp = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            formvalidated = testexp.test(String(email.val()).toLowerCase());
            if (!formvalidated) {
                formvalidated = false;
                thisParent.addClass('formemailerror');
                if (email.val() == '') email.addClass('fielderror');
                return false;
            }
            if (name.val() == '' || email.val() == '' || phone.val() == '' || date.val() == '' || time.val() == '' || zip.val() == '' || country.val() == '') {
                formvalidated = false;
                thisParent.addClass('formerror');
                if (name.val() == '') name.addClass('fielderror');
                if (email.val() == '') email.addClass('fielderror');
                if (phone.val() == '') phone.addClass('fielderror');
                if (date.val() == '') date.addClass('fielderror');
                if (time.val() == '') time.addClass('fielderror');
                if (zip.val() == '') zip.addClass('fielderror');
                if (country.val() == '') country.addClass('fielderror');
                return false;
            }

            // pass data to ajax page
            if (formvalidated) {
                $.ajax({
                    type: 'POST',
                    url: ajaxPath,
                    data: {
                        gate: 'birthdayrequest',
                        franchiseid: franchiseid.val(),
                        name: name.val(),
                        email: email.val(),
                        phone: phone.val(),
                        date: date.val(),
                        time: time.val(),
                        zip: zip.val(),
                        country: country.val(),
                        packagetype: packagetype.val(),
                        comments: comments.val()
                    },
                    success: function (data) {
                        var response = $.parseJSON(data);
                        //console.log(response);
                        if (response.ajaxsuccess && response.sendsuccess) {
                            var html = '';
                            if (response.sentto == 'corporate') {
                                // replace form with slaes text
                                var html = '<h3>Thank You!</h3><br><h5><p>We\'re currently not offering Birthday Parties in your area.</p><p>Would you like to create a career you love?</p></h5><a class="formresponseaction" href="/franchise/" target="">Learn More</a>';
                            }
                            else {
                                // replace form with thank you text
                                var html = '<h3>Thank You!</h3><br><h5><p>We\'ve received your information and will be contacting you shortly.</h5></p><a class="formresponseaction" href="/'+franchiseslug+'/franchise" target="">Click Here for more information</a>';
                            }

                            $this.html(html);
                        }
                        else {
                            console.log(response);
                        }
                    }
                });

                return false;
            }
            return false;
        });


        // submit the personal data request form to ajax
        $('#personaldatarequestform').submit(function (e) {
            e.preventDefault();
            var $this = $(this);
            var thisParent = $this.parent();
            var thisfranchid = $this.find('[name="franchiseid"]').val();
            var email = $this.find('[name="email"]').val();
            var country = $this.find('[name="country"]').val();
            var requesttype = $this.find('[name="requesttype"]:checked').val();
            var datatype1 = $this.find('[name="datatype1"]:checked').val();
            var datatype2 = $this.find('[name="datatype2"]:checked').val();
            var datatype3 = $this.find('[name="datatype3"]:checked').val();
            var datatype4 = $this.find('[name="datatype4"]:checked').val();

            thisParent.removeClass('formerror');
            $this.find('fieldset').removeClass('fielderror');

            // validate form data
            var formvalidated = true;

            // validate email
            var testexp = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            emailvalidated = testexp.test(String(email).toLowerCase());
            if( !emailvalidated || email == '' ) {
                formvalidated = false;
                $('#emailfields').addClass('fielderror');
            }

            // validate radio
            if( !requesttype ) {
                formvalidated = false;
                $('#requesttypefields').addClass('fielderror');
            }

            // validate checkbox
            if( !datatype1 && !datatype2 && !datatype3 && !datatype4 ) {
                formvalidated = false;
                $('#datatypefields').addClass('fielderror');
            }

            // validate country
            if( country == '' ) {
                formvalidated = false;
                $('#countryfields').addClass('fielderror');
            }

            if( !formvalidated ) {
                thisParent.addClass('formerror');
                return false;
            }

            // pass data to ajax page
            if( formvalidated ) {
                $.ajax({
                    type: 'POST',
                    url: ajaxPath,
                    data: {
                        gate: 'personaldatarequest',
                        franchiseid: thisfranchid,
                        requesttype: requesttype,
                        email: email,
                        country: country,
                        datatype1: datatype1,
                        datatype2: datatype2,
                        datatype3: datatype3,
                        datatype4: datatype4
                    },
                    success: function (data) {
                        var response = $.parseJSON(data);
                        //console.log(response);
                        if (response.ajaxsuccess && response.sendsuccess) {
                            // replace form with thank you text
                            var html = '<h3>Thank You!</h3><br><h5>We\'ve received your request and will be contacting you shortly.</h5>';
                            $this.html(html);
                        }
                        else {
                            console.log(response);
                        }
                    }
                });

                return false;
            }
            return false;
        });
        
        // submit the have-a-question form to ajax
        $('#publicfranchisecontactform .publicfranchisecontactform').submit(function (e) {
            e.preventDefault();
            var $this = $(this);
            var thisParent = $('#publicfranchisecontactform');
            var franchiseid = $this.find('[name="franchiseid"]');
            var first = $this.find('[name="first"]');
            var last = $this.find('[name="last"]');
            var email = $this.find('[name="email"]');
            var phone = $this.find('[name="phone"]');
            var comments = $this.find('[name="comments"]');
            thisParent.removeClass('formerror');
            thisParent.removeClass('formemailerror');
            $this.find('input[type="text"]').removeClass('fielderror');

            // validate form data
            var formvalidated = true;
            var testexp = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            formvalidated = testexp.test(String(email.val()).toLowerCase());
            if (!formvalidated) {
                formvalidated = false;
                thisParent.addClass('formemailerror');
                if (email.val() == '') email.addClass('fielderror');
                return false;
            }
            if (first.val() == '' || last.val() == '' || email.val() == '' || phone.val() == '' || comments.val() == '') {
                formvalidated = false;
                thisParent.addClass('formerror');
                if (first.val() == '') first.addClass('fielderror');
                if (last.val() == '') last.addClass('fielderror');
                if (email.val() == '') email.addClass('fielderror');
                if (phone.val() == '') phone.addClass('fielderror');
                if (comments.val() == '') comments.addClass('fielderror');
                return false;
            }

            // pass data to ajax page
            if (formvalidated) {
                $.ajax({
                    type: 'POST',
                    url: ajaxPath,
                    data: {
                        gate: 'informationrequest',
                        franchiseid: franchiseid.val(),
                        first: first.val(),
                        last: last.val(),
                        email: email.val(),
                        phone: phone.val(),
                        comments: comments.val()
                    },
                    success: function (data) {
                        var response = $.parseJSON(data);
                        //console.log(response);
                        if (response.ajaxsuccess && response.sendsuccess) {
                            // replace form with thank you text
                            var html = '<h3>Thank You!</h3><br><h5>We\'ve received your information and will be contacting you shortly.</h5>';
                            $this.html(html);
                        }
                        else {
                            console.log(response);
                        }
                    }
                });

                return false;
            }
            return false;
        });


        // submit the request-a-class form to ajax
        $('#publicrequestaclassform .publicrequestaclassform').submit(function (e) {
            e.preventDefault();
            var $this = $(this);
            var thisParent = $('#publicrequestaclassform');
            var franchiseid = $this.find('[name="franchiseid"]');
            var first = $this.find('[name="first"]');
            var last = $this.find('[name="last"]');
            var email = $this.find('[name="email"]');
            var zip = $this.find('[name="zip"]');
            var schoolname = $this.find('[name="schoolname"]');
            thisParent.removeClass('formerror');
            thisParent.removeClass('formemailerror');
            $this.find('input[type="text"]').removeClass('fielderror');

            // validate form data
            var formvalidated = true;
            var testexp = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            formvalidated = testexp.test(String(email.val()).toLowerCase());
            if (!formvalidated) {
                formvalidated = false;
                thisParent.addClass('formemailerror');
                if (email.val() == '') email.addClass('fielderror');
                return false;
            }
            if (first.val() == '' || last.val() == '' || email.val() == '' || zip.val() == '' || schoolname.val() == '') {
                formvalidated = false;
                thisParent.addClass('formerror');
                if (first.val() == '') first.addClass('fielderror');
                if (last.val() == '') last.addClass('fielderror');
                if (email.val() == '') email.addClass('fielderror');
                if (zip.val() == '') zip.addClass('fielderror');
                if (schoolname.val() == '') schoolname.addClass('fielderror');
                return false;
            }

            // pass data to ajax page
            if (formvalidated) {
                $.ajax({
                    type: 'POST',
                    url: ajaxPath,
                    data: {
                        gate: 'classroomrequest',
                        franchiseid: franchiseid.val(),
                        first: first.val(),
                        last: last.val(),
                        email: email.val(),
                        zip: zip.val(),
                        schoolname: schoolname.val()
                    },
                    success: function (data) {
                        var response = $.parseJSON(data);
                        //console.log(response);
                        if (response.ajaxsuccess && response.sendsuccess) {
                            // replace form with thank you text
                            var html = '<h3>Thank You!</h3><br><h5>We\'ve received your information and will be contacting you shortly.</h5>';
                            $this.html(html);
                        }
                        else {
                            console.log(response);
                        }
                    }
                });

                return false;
            }
            return false;
        });


        // Instantiate Colorbox
        function wireColorbox() {
            var w = window.innerWidth * .9;
            var h = window.innerHeight * .9;
            var setW = w;
            var setH = h;
            var ratio = h / w;
            if (ratio > 0.5625) {
                // width takes priority
                var setH = w * 9 / 16;
            } else {
                // height takes priority
                var setW = h * 16 / 9;
            }

            $.colorbox({
                href: this.href,
                iframe: true,
                width: setW,
                height: setH
            });
            return false;
        }


        // format franchise info
        function setfranchiseinfo(franchiseinfo) {
            var franchisehtml = '';
            franchisehtml += '<div class="franchiselist-franchise" data-franchiseid="' + franchiseinfo.franchiseid + '">';
            franchisehtml += '<div class="franchiselist-franchisename">' + franchiseinfo.franchisecreativecentername + '</div>';
            franchisehtml += '<div class="franchiselist-franchiseaddress">';
            franchisehtml += '<span class="franchiselist-franchiseaddress">' + franchiseinfo.addressstreet + '</span><br>';
            franchisehtml += '<span class="franchiselist-franchisecity">' + franchiseinfo.addresscity + '</span>, ';
            franchisehtml += '<span class="franchiselist-franchisestate">' + franchiseinfo.addressstate + '</span> ';
            franchisehtml += '<span class="franchiselist-franchisezip">' + franchiseinfo.addresszip + '</span><br>';
            franchisehtml += '<span class="franchiselist-franchisecountry">' + franchiseinfo.addresscountry + '</span>';
            franchisehtml += '</div>';
            franchisehtml += '</div>';
            return franchisehtml;
        }


        // franchise cookies (may not be in use, but still being set on the team page)
        function setfranchiseinfocookies(franchiseinfo) {
            // load values
            var locPlace = franchiseinfo.addresscountry + ', ' + franchiseinfo.addressstate + ', ' + franchiseinfo.addresscity;
            var locCode = franchiseinfo.franchiseid;
            // set locally
            localStorage.setItem('location-place', locPlace);
            localStorage.setItem('location-code', locCode);
            // update page
            $('#franchiselocation').html(locPlace);
            $('#franchiselocation_mobile').html(locPlace);
            $('body').removeClass('no-location').addClass('current-location');
        }
        // location search input
        function locationsearch_suggestionbox_init(inputselector, page) {
            userlocation = '';
            getuserlocationpromise().then((userlocation) => {
                //console.log("userlocation lat: "+userlocation.lat);
                //console.log("userlocation lng: "+userlocation.lng);
                var locationstring = JSON.stringify(userlocation);
                //console.log("locationstring str: "+locationstring);
                $(inputselector).append("<div class='locationsearch-suggestionbox-results' id='locationsearch-suggestionbox-results-" + page + "' ></div>");
                var inputtimer = 0;
                $(inputselector).find('input').keyup(function () {
                    now = new Date();
                    inputtimer = now.getMilliseconds() + now.getSeconds() * 1000;
                    setTimeout(function () {
                        current = new Date();
                        ts = current.getMilliseconds() + current.getSeconds() * 1000;
                        console.log('time', inputtimer);
                        console.log('ts', ts);
                        console.log('timediff', ts - inputtimer);
                        if (ts - inputtimer < 325)
                            return false;
                        $('#locationsearch-suggestionbox-results-' + page).html('');
                        waiticon('#locationsearch-suggestionbox-results-' + page);
                        $.ajax({
                            method: 'POST',
                            url: ajaxPath,
                            data: {
                                gate: 'locationsuggestionbox',
                                page: page,
                                searchval: $(inputselector).find('input').val(),
                                userlocation: locationstring,
                            },
                            success: function (data) {
                                $('#locationsearch-suggestionbox-results-' + page).html(data);
                                inputtimer = now.getMilliseconds() + now.getSeconds() * 1000;
                            }
                        })
                    }, 425);
                })
            })
            $(inputselector).closest('form').focusout(function () {
                if (!$('.locationsearch-suggestionbox-results-item').is(':focus') && !$('#locationsearch-suggestionbox-results-' + page).is(':focus'))
                    setTimeout(function () { $('#locationsearch-suggestionbox-results-' + page).hide(); }, 250);
            })
            $(inputselector).closest('form').focusin(function () {
                $('#locationsearch-suggestionbox-results-' + page).show();
                if ($(inputselector).find('input').val().length > 0)
                    $(inputselector).find('input').keyup();
            })
        }
        function waiticon(selector)
        {
            if(!$(selector).find('.waitwall').length)
                $(selector).prepend("<div class='waitwall'><img src='/images/ajax_loading.gif'/></div>");
        }
        locationsearch_suggestionbox_init('#publiclocctasearchinputwrapper', 'home');
        $('.clickonload').click();
    })

    // apply a min-height to the blog, so sidebar doesn't overflow footer
    if ($('#publicblogsidebar').length > 0) { 
        var $this = $('#publicblogsidebar');
        var minheight = $this.height();
        $this.parent().css('min-height',minheight+50+'px');
    }

})(jQuery);

function getuserlocationpromise() {
    return new Promise((resolve) => {
        if (navigator.geolocation)//need to pass userlocation to public_ajax in order to sort result by proximity
        {
            userlocation = { lat: 37.090240, lng: -95.712891 };//hardcoded center of usa location
            navigator.geolocation.getCurrentPosition(function (position) {
                userlocation = { lat: position.coords.latitude, lng: position.coords.longitude }
                console.log("userlocation lat: " + userlocation.lat)
                console.log("userlocation lng: " + userlocation.lng)
                
            },
                function (error) {//permission to use userlocation denied
                    userlocation = { lat: 37.090240, lng: -95.712891 };//hardcoded center of usa location
                    console.log("userlocation lat: " + userlocation.lat)
                    console.log("userlocation lng: " + userlocation.lng)
                    
                });
            resolve(userlocation);
        }
    })
}
function ValidateEmail(emailaddress) {
    if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(emailaddress)) {
        return (true)
    }
    return (false)
}

function setCookie(name, value, days) {
    var expires = "";
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toUTCString();
    }
    document.cookie = name + "=" + (value || "") + expires + "; path=/;";
}
function getCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
    }
    return null;
}
function eraseCookie(name) {
    document.cookie = name + '=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/;';
}
function modal_load(title, url, urlreturn,scriptonclose)
{ 
	modaltitle = title;
	container_load(url, urlreturn, '#modal',modaltitle, scriptonclose)
}
function modal_close()
{
    modal_close_script()
    container_close('#modal')
}
function modal_close_script()
{
    var count = $('#modal').data('updatefield-count')
    if(count)
    { 
        document.location.href=document.location.href; //reload the screen
        return;
    }  
    var reloadonclose = $('#modal').attr('reloadonclose');
    var scriptonclose = $('#modal').attr('scriptonclose');
    if(scriptonclose)
        eval(scriptonclose);
    else if(reloadonclose) 
        document.location.href=document.location.href
}
var container_breadcrumbs = [];
var container_submit_name = '';
var container_submit_value = '';
function container_load(url, urlreturn, containerselector, title, scriptonclose)
{
    console.log("Container loading...");
    console.log(containerselector);
	
    container_open(title, "",containerselector);
    container = $(containerselector);
    if(scriptonclose)
        container.attr('scriptonclose', scriptonclose);
    if(!container.attr('href')||container.attr('href')=='false')
        container.attr('href',url);
    var contentarea = container;
    var containertitle = false;
    var containerbreadcrumbs = false;
    var containerbodyname = container.data('bodyclass');
    if(containerbodyname)
        contentarea = $("."+containerbodyname);
    var containertitlename = container.data('titleclass');
    if(containertitlename)
        containertitle = $("."+containertitlename);
    var containerbreadcrumbsname = container.data('breadcrumbsclass');
    if(containerbreadcrumbsname)
        containerbreadcrumbs = $("."+containerbreadcrumbsname);
    if(url.indexOf("?")<1)
        url +='?'
    else
        url +='&'
    waiticon(contentarea);
    url += 'in_modal=1';
    url += '&container=1';
    contentarea.load(url,function()
    { 
            console.log('contentarea.load.function');
            var loadingtitle = title;
            container_processcontent(containerselector);
			
            var head2 = $(container).find('.head2');
            if (head2.length > 0)
            {
                    head2 = head2[0];
                    loadingtitle = $(head2).text();
                    if(containertitle.length>0)
                        $(head2).remove();
            }
            if(!loadingtitle)
                    var loadingtitle = '&nbsp;';
            if(containertitle)
            {
                containertitle.html(loadingtitle);
            }

            if (urlreturn)
            {
                var urlobj = {};
                urlobj[loadingtitle] = url;

                var notdupe = true;
                $.each(container_breadcrumbs, function(i, e) 
                {
                    $.each(e, function(name, bc_url) 
                    {
                        if (bc_url == url)
                        {
                            notdupe = false;
                        }
                    })
                });
                if (notdupe)
                        container_breadcrumbs.push(urlobj);
            }

            var text_breadcrumbs = sep = "";
            text_breadcrumbs+="<div class='breadcrumb-case'><ul class='breadcrumb'>";
            $.each(container_breadcrumbs, function(i, e) 
            {
                    $.each(e, function(name, bc_url) 
                    {
                            if (bc_url == url)
                                    notdupe = false;
                            text_breadcrumbs += sep+"<li class=''><a onclick=\"container_reload('"+bc_url+"','"+containerselector+"','"+loadingtitle+"')\" style='cursor:pointer;'>"+name+"</a></li>";
                            sep = " > ";
                    })
            });
            text_breadcrumbs+="</ul></div>";
            
            if(container_breadcrumbs.length > 0)
            {
                console.log('breadcrumbs','on');
                containerbreadcrumbs.css('display','block');          
                containerbreadcrumbs.html(text_breadcrumbs);
            }
            else
            {
                console.log('breadcrumbs','off');
                if(typeof(containerbreadcrumbs.css) !== 'undefined')
                    containerbreadcrumbs.css('display','none');
            }
    });
}
function container_open(title, content, containerselector)
{
    var container = $(containerselector);
    var contentarea = container;
    var containerbodyname = container.data('bodyclass');
    if(containerbodyname)
            contentarea = $("."+containerbodyname);
    var containertitlename = container.data('titleclass');
    if(containertitlename)
    {
            $("."+containertitlename).html(title);
    }
    if(container.data('openclass'))
            $("body").addClass(container.data('openclass'));

    contentarea.html(content);
    container_processcontent(containerselector);
    setTimeout(function(){
			set_focusedinputs()
		},0)
}
function container_processcontent(containerselector)
{
    $(containerselector).attr('container_selector_name',containerselector)
    $(containerselector).find('form').each(function()
    {
        var frm = $(this);
        var attrformsubmitbyajax = $(frm).attr('formsubmitbyajax');
        var formsubmitbyajax = (typeof attrformsubmitbyajax !== typeof undefined && attrformsubmitbyajax !== false) ? true : false;
		if(!formsubmitbyajax)
		{
			frm.submit(function(){
				console.log('form submit hijacked by function container_processcontent()')
				container_submit(this, containerselector,container_submit_name);
				return false;
			});
		}
    });
    $(containerselector).find('a').each(function()
    { 
        var href = $.trim($(this).attr('href'))
        if(href.slice(0,2)=='//' || href.slice(0,4)=='http')
        	return;
        if($(this).hasClass('container-tabcontent'))
            return;
        if($(this).attr('target'))
            return;
    	$(this).unbind('click')
    	$(this).click(function(e)
    	{
	        var href = $(this).attr('href')
	        if(typeof(href)=='undefined')
	             return;
	        if(href.indexOf('javascript') > -1)
	             return;
	        if($(this).hasClass('container-tabcontent') && containerselector.indexOf('tab_content')==-1)
                {
                    var type = '';
                    var startindex = href.indexOf('type=')+5;
                    var endindex = href.indexOf('&',startindex);
                    if(endindex != -1)
                        type = href.substring(startindex, endindex);
                    else
                        type = href.substring(startindex);
                    if(type)
                        containerselector = containerselector+" ."+type+"tab_content";
                }
	        container_load(href,'',containerselector)
	        e.preventDefault();
	        return false;
    	})
     })
    $(containerselector).find('input[type=submit]').click(function(){
        container_submit_name = $(this).attr('name');
        container_submit_value = $(this).val();
    }) 
	$(containerselector).attr('container_processcontent','true')
}
function container_submit(frm, containerselector,submitname)
{   
    if(frm)
        if($(frm).prop("tagName")!='form')
            frm=$(frm).closest('form');
    if(!frm)
        frm = $(containerselector).find('form');
    if(!frm&&containerselector)
        frm = $(containerselector).find('form');   
        
        
    if(frm.data('submitting')=='1')
            return;;
    frm.data('submitting','1');
    if(!containerselector)
    {
        containerselector=container_closest(frm).attr('container_selector_name')
        //alert(containerselector)
    } 
    if(container_submit_name)
    {
        if($('[name='+container_submit_name+']').hasClass('nocontainersubmit'))
            $(frm).unbind('submit').submit();
    }
      
    var fdata = $(frm).serialize();

    if(!submitname)
    	submitname = 'submit'; 
    fdata = fdata+"&container=1&submit="+submitname; 
    
    if(container_submit_name)
        fdata += "&"+container_submit_name+"="+container_submit_value;
    
    var container = $(containerselector);
  //  alert($(frm).attr('action'))
  //  alert(container.attr('href'))
    if(!$(frm).attr('action')&&container.attr('href'))
    { 
        $(frm).attr('action',container.attr('href'))
    }
    var furl = $(frm).attr('action');  
    var containertitlename = container.data('titleclass');
    var title = '';
    if(containertitlename)
        title = $("."+containertitlename).html();
    $.ajax({
        url:furl
        , data: fdata
        , method: 'POST'
        , success: function (message) {
            container_open(title, message,containerselector)
        }
    })  
}
function container_closest(obj)
{
	var container =  $(obj).closest('[container_selector_name]'); 
	if(container.length>0)
		return container; 
	return false
	

}
function waiticon(selector)
{
    if(!$(selector).find('.waitwall').length)
        $(selector).prepend("<div class='waitwall'><img src='/images/ajax_loading.gif'/></div>");
}
function set_focusedinputs(force)
		{
			
			
			
			
			if($('#pagecontent').hasClass('pagetype-edit') || $('#pagecontent').hasClass('pagetype-submenu') || force > 0)
			{
				//console.log("Setting the enhanced inputs")
				// if we find two inputs in a td add a class to control this
				
				$.each($("form table").find('input[type=text]'),function(){
							
					//console.log($(this).closest("td").children("div").length);
					if($(this).closest("#multipledatepicker-wrapper").length >0 )
						return;
					if($(this).hasClass('input-ui-disallow') || $(this).closest('tr').hasClass('input-ui-disallow'))
						return;
					if(!$(this).hasClass('double-input-ui-disallow'))
						if($(this).closest("td").find('input[type=text]').length ==2)
							$(this).closest("tr").addClass("double-input-ui");
					if(!$(this).hasClass('double-input-ui-disallow'))
						if($(this).closest("td").children("div").length >1)
							$(this).closest("tr").addClass("double-input-ui");
					
					$(this).addClass('focusedinput')
				})
				$.each($("form table").find('input[type=file]'),function(){
							
					//console.log($(this).closest("td").children("div").length);
					if($(this).closest("#multipledatepicker-wrapper").length >0 )
						return;
					if($(this).hasClass('input-ui-disallow') || $(this).closest('tr').hasClass('input-ui-disallow'))
						return;
					if($(this).closest("td").children("div").length >1)
						$(this).closest("tr").addClass("file-input-ui");
				})
				$.each($("form table").find('select'),function(){
							
					if($(this).closest("#multipledatepicker-wrapper").length >0 )
						return;
					if($(this).hasClass('input-ui-disallow') || $(this).closest('tr').hasClass('input-ui-disallow'))
						return;
					if(!$(this).hasClass('double-input-ui-disallow'))
						if($(this).closest("td").find('input[type=text]').length ==2)
							$(this).closest("tr").addClass("double-input-ui");
					if(!$(this).hasClass('double-input-ui-disallow'))
						if($(this).closest("td").children('div').length >1)
							$(this).closest("tr").addClass("double-input-ui");
				})
				$.each($("form table").find('[btn-icon-button]'),function(){
					
					if($(this).closest("#multipledatepicker-wrapper").length >0 )
						return;
					if($(this).hasClass('input-ui-disallow') || $(this).closest('tr').hasClass('input-ui-disallow'))
						return;
					if(!$(this).hasClass('double-input-ui-disallow'))
						{
							if($(this).closest('tr').find('th').is(':empty'))
								{
									$(this).closest("tr").addClass("fullwidth-ui");
									return;
								}else
								{
									if($(this).closest("td").find('input[type=text]').length ==2)
										$(this).closest("tr").addClass("double-input-ui");
								}
							
							
							
						}
					if(!$(this).hasClass('double-input-ui-disallow'))
						{
							if($(this).closest("td").children().length >1)
								$(this).closest("tr").addClass("double-input-ui");
						}
					if(!$(this).hasClass('fullwidth-ui-disallow'))
						{
							if($(this).closest("td").children('div').length ==1)
								$(this).closest("tr").addClass("fullwidth-ui");
							
						}
				})
				$.each($("form table").find('[btn-icon-input]'),function(){
							
					if($(this).closest("#multipledatepicker-wrapper").length >0 )
						return;
					if($(this).hasClass('input-ui-disallow') || $(this).closest('tr').hasClass('input-ui-disallow'))
						return;
					if(!$(this).hasClass('double-input-ui-disallow'))
						if($(this).closest("td").find('input[type=text]').length ==2)
							$(this).closest("tr").addClass("double-input-ui");
					if(!$(this).hasClass('double-input-ui-disallow'))
						if($(this).closest("td").children('div').length >1)
							$(this).closest("tr").addClass("double-input-ui");

					if(!$(this).hasClass('fullwidth-ui-disallow'))
						if($(this).closest("td").children('div').length ==1)
							$(this).closest("tr").addClass("fullwidth-ui");
				})
				
				$.each($("form table").find('input[type=password]'),function(){
					//console.log($(this).closest("td").children("div").length);
					$(this).addClass('focusedinput')
				})
				
				$.each($("form table").find('input,select,textarea'),function(){
					// we need classes or attributed on these things - anything so they can be targeted in css
					$(this).closest('tr').attr('formfield',$(this).attr('name'))
				})
				
				
				$.each($("form table").find('input[name=countrymapposition]'),function(){
					//console.log($(this).closest("td").children("div").length);
					$(this).addClass('focusedinput')
					$(this).closest("tr").addClass("fullwidth-ui");
					$(this).closest("td").css({"display":"block"});
				})
				
				$.each($('.focusedinput'),function(){
                                    if($(this).closest('form').attr('action')=='object.php?type=schedule&add=1&expand=')
                                        return;
                                    if($(this).closest('form').attr('action')=='object.php?type=schedule&add=1&expand=')
                                        return;                                            
                                    if(!$(this).hasClass('fi-hl-disallow') && !$(this).closest(".fi-hl").length)
                                    {
                                        $(this).wrap("<div class='fi-hl' style='margin:0 3px'></div>");
                                        $(this).closest('.fi-hl').append("<span class=highlight></span><span class=bar></span>");
                                    }
				})
				
				/*
				to be imlemented when labels are ready
				console.log('I am in doc ready and being called')
	
				$.each($('input[type=text]'),function(){

					if(!$(this).closest('form').hasClass('enhanced-user-interface'))
						$(this).closest('form').addClass('enhanced-user-interface')

					$(this).addClass('focusedinput2')
					$(this).attr('id',$(this).attr('name'))
					$(this).wrap('<label for='+$(this).attr('name')+' ></label>')
				});
				*/
			}
        }
        function container_close(containerselector)
        {
            $(containerselector).attr('href',false);
            if (container_breadcrumbs.length > 1)
            {
                    container_breadcrumbs.pop();
                    var urlobj = container_breadcrumbs.pop();
                    var lasturl;
                    $.each(urlobj, function(name, url) 
                    {
                            lasturl = url;
                    });
                    container_load(lasturl,1,containerselector);
            }
            else
            {
                container_breadcrumbs = [];
                var container = $(containerselector);
                if(container.data('openclass'))
                    $("body").removeClass(container.data('openclass'));
                
                var containertitlename = container.data('titleclass');
                if(containertitlename)
                    $("."+containertitlename).html();
        //new process,   modals reload only when told to explicitly by runing javascript:modal_reload_onclose()
        /*
                try //Add modal_close_page_reload(){return 1;} to any page that wants to be reloaded on modal_close(), including after a modal_submit().
                { 
                        if(container_pageneedsreload() || modal_close_page_reload())
                                location.reload();
                        else if(container_close_page_reload() || containerclosepagereload)
                                location.reload();
                }
                catch(e)
                {
                }
        */
            }
        }        